SET AUTODDL on;

connect 'C:\Logic\Datos\Logic_cr.gdb' user 'SYSDBA' password 'masterkey';

COMMIT WORK;
SET term ^;
CREATE PROCEDURE INSERT_RGT_DIRECT2 (NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,NUMJRNL CHAR(3),LIB VARCHAR(50),NUMFACT INTEGER,MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,MDRGLT CHAR(4),CODOPE VARCHAR(10),CODINSEE CHAR(5),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER,NUMLOTE VARCHAR(10),CODIGODEPAGO INTEGER)  RETURNS  (NUMRGT INTEGER) AS BEGIN exit; END^
CREATE TABLE BITACORA_NODOS (CODIGO_HEADEND VARCHAR(5) NOT NULL,
CODIGO_HUB VARCHAR(5) NOT NULL,
NUMNODE VARCHAR(10) NOT NULL,
FECHA DATE NOT NULL,
HORA INTEGER NOT NULL,
ESTADO INTEGER NOT NULL,
USUARIO VARCHAR(10) NOT NULL,
COMENTARIO VARCHAR(250),
PRIMARY KEY (CODIGO_HEADEND , CODIGO_HUB , NUMNODE , FECHA , HORA , ESTADO)
)^

CREATE TABLE ESTADO_NODO (ESTADO INTEGER NOT NULL,
DETALLE VARCHAR(20),
TIPO VARCHAR(1),
PRIMARY KEY (ESTADO)
)^

CREATE TABLE LOTE_DESC_RACSA (ORDRE INTEGER NOT NULL,
FECHA_CARGA DATE,
CODOPE VARCHAR(10),
NUMCLIALOPA VARCHAR(10),
ESTADO DOM_BOOL,
FECHA_DESCO DATE,
NUMINTER INTEGER,
GESTIONADO VARCHAR(1),
GESTIONO VARCHAR(10),
INTE VARCHAR(15) NOT NULL,
CONSTRAINT PK1_LOTE_DESC_RACSA PRIMARY KEY (INTE , ESTADO)
)^

CREATE TABLE LOTE_RECO_RACSA (ORDRE INTEGER NOT NULL,
FECHA_CARGA DATE,
CODOPE VARCHAR(10),
NUMCLIALOPA VARCHAR(10),
ESTADO DOM_BOOL,
NUMINTER INTEGER,
INTE VARCHAR(15) NOT NULL,
ESTADO_ORDEN VARCHAR(1),
FECHA_RECO DATE,
CONSTRAINT PK1_LOTE_RECO PRIMARY KEY (INTE , ESTADO)
)^

CREATE TABLE PAGOS_EN_LINEA (NUMPIECE INTEGER NOT NULL,
NUMABONNE INTEGER NOT NULL,
CODIGO_PAGO INTEGER NOT NULL,
RECAUDADOR VARCHAR(10),
MONTO PRICE,
FECHA_PAGO DATE NOT NULL,
CONSTRAINT PK1_PAGOS_EN_LINEA PRIMARY KEY (CODIGO_PAGO)
)^

/*    */
CREATE TABLE SOLICITUD_CABIO_PRECIO (ID INTEGER NOT NULL,
USUARIO_SOLICITA CHAR(10),
CODPROD CHAR(4),
FECHA_SOLICITUD DATE,
NOMBRE_SOLICITANTE VARCHAR(50),
FEHA_APLICACION DATE,
NOMBRE_APRUEBA VARCHAR(50),
APROBADO DOM_BOOL,
USUARIO_APROBO VARCHAR(10),
PRECIO_NUEVO FLOAT,
USUARIO_APLICO VARCHAR(10),
FECHA_APROBACION DATE,
APLICADO DOM_BOOL,
CONSTRAINT PK_SOLICITUD_CABIO_PRECIO PRIMARY KEY (ID)
)^

/* Datos Generales de Clientes (abonados)  */
ALTER TABLE ABONNE
ADD GESTION VARCHAR(1),
ADD MOTIVO_GESTION VARCHAR(3),
ADD FECHA_GESTION DATE,
ADD GESTOR VARCHAR(10)
^

ALTER TABLE CABLEMODEMSERV
ADD POLITICA CHAR(10)
^

ALTER TABLE CANTONES
DROP CONSTRAINT /* Insert constraint name for PRIMARY KEY */,
DROP CPAIS,
ADD CPAIS VARCHAR(3) NOT NULL,
ADD PRIMARY KEY (CPAIS , CPROV , CCANTON)
^

ALTER TABLE DISTRITOS
DROP CONSTRAINT /* Insert constraint name for PRIMARY KEY */,
DROP CPAIS,
ADD CPAIS VARCHAR(3) NOT NULL,
ADD PRIMARY KEY (CPAIS , CPROV , CCANTON , CDISTRI)
^

/* Contiene lineas de contabilidad  */
ALTER TABLE ECRITCPT
ADD CODIGODEPAGO INTEGER
^

/* Contiene informacion acerca de vendedores, tecnicos y cobradores  */
ALTER TABLE INTERVENANT
DROP PRENOM,
DROP CODINSEE,
ADD CODINSEE CHAR(3)
^

/* Contiene informacin acerca de ordenes de trabajo  */
ALTER TABLE INTERVENTION
DROP RG59,
DROP RG6,
DROP RF59,
DROP F81,
DROP F56,
DROP PREF,
DROP FAJA,
DROP DIV2V,
DROP DIV3V,
DROP DIV4V,
DROP AMPL10,
DROP AMPL20,
DROP INTERAB,
DROP GPSC
^

ALTER TABLE LOCALIZACION_NODO
DROP CODIGO_HEADEND,
DROP CODIGO_HUB,
ADD CODIGO_HEADEND VARCHAR(5) NOT NULL,
ADD CODIGO_HUB VARCHAR(5) NOT NULL,
ADD PRIMARY KEY (CODINSEE , LOCALISATION , CODIGO_HEADEND , CODIGO_HUB , NUMNODE)
^

ALTER TABLE LOCALIZATION
DROP CONSTRAINT LOCALIZATIONPRIMARYKEY1,
DROP CPAIS,
DROP CPROV,
DROP CCANTON,
DROP CDISTRI,
ADD CPAIS VARCHAR(3) NOT NULL,
ADD CPROV VARCHAR(3) NOT NULL,
ADD CCANTON VARCHAR(3) NOT NULL,
ADD CDISTRI VARCHAR(3) NOT NULL,
ADD PRIMARY KEY (CODINSEE , LOCALISATION)
^

ALTER TABLE MOORE
ADD CODINSEE JOURNAL
^

ALTER TABLE NODE
DROP CONSTRAINT NODEPRIMARYKEY1,
DROP ESTADO,
DROP CODIGO_HEADEND,
DROP CODIGO_HUB,
ADD CODIGO_HEADEND VARCHAR(5) NOT NULL,
ADD CODIGO_HUB VARCHAR(5) NOT NULL,
ADD COMENTARIO_ESTADO VARCHAR(250),
ADD ESTADO INTEGER NOT NULL,
ADD PRIMARY KEY (CODIGO_HEADEND , CODIGO_HUB , NUMNODE)
^

ALTER TABLE PROVINCIAS
DROP CONSTRAINT /* Insert constraint name for PRIMARY KEY */,
DROP CPAIS,
ADD CPAIS VARCHAR(3) NOT NULL,
ADD PRIMARY KEY (CPAIS , CPROV)
^

ALTER TABLE TEMPINTES
ADD MOVIM CHAR(1)
^

/* Guarda Los registros de venta para los clientes. Se actualiza en la fecha con cada cambio que se haga.  */
ALTER TABLE VENTE
ADD DTRESI2 DATE
^

DROP TABLE TEMPDECORACSA^

CREATE INDEX PROPSERVINDEX1 ON PROPSERV(ORDRE)^

CREATE INDEX TEMPRACSAINTEINDEX1 ON TEMPRACSAINTE(NUMABONNE)^

COMMIT WORK^

ALTER TABLE BITACORA_NODOS ADD FOREIGN KEY (ESTADO) REFERENCES ESTADO_NODO(ESTADO) ON UPDATE cascade^
ALTER TABLE BITACORA_NODOS ADD FOREIGN KEY (CODIGO_HEADEND , CODIGO_HUB , NUMNODE) REFERENCES NODE(CODIGO_HEADEND , CODIGO_HUB , NUMNODE) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE CANTONES ADD FOREIGN KEY (CPAIS , CPROV) REFERENCES PROVINCIAS(CPAIS , CPROV) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE DISTRITOS ADD FOREIGN KEY (CPAIS , CPROV , CCANTON) REFERENCES CANTONES(CPAIS , CPROV , CCANTON) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE HUB ADD FOREIGN KEY (CODIGO_HEADEND) REFERENCES HEADEND(CODIGO_HEADEND) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE LOCALIZACION_NODO ADD FOREIGN KEY (CODIGO_HEADEND , CODIGO_HUB , NUMNODE) REFERENCES NODE(CODIGO_HEADEND , CODIGO_HUB , NUMNODE) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE LOCALIZACION_NODO ADD FOREIGN KEY (CODINSEE , LOCALISATION) REFERENCES LOCALIZATION(CODINSEE , LOCALISATION) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE LOCALIZATION ADD FOREIGN KEY (CPAIS , CPROV , CCANTON , CDISTRI) REFERENCES DISTRITOS(CPAIS , CPROV , CCANTON , CDISTRI) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE LOCALIZATION ADD FOREIGN KEY (CODINSEE) REFERENCES COMMUNE(CODINSEE) ON UPDATE cascade^
ALTER TABLE NODE ADD FOREIGN KEY (CODIGO_HEADEND , CODIGO_HUB) REFERENCES HUB(CODIGO_HEADEND , CODIGO_HUB) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE NODE ADD FOREIGN KEY (ESTADO) REFERENCES ESTADO_NODO(ESTADO) ON UPDATE cascade^
ALTER TABLE PRISE ADD FOREIGN KEY (NUMABONNE) REFERENCES ABONNE(NUMABONNE) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE PROVINCIAS ADD FOREIGN KEY (CPAIS) REFERENCES PAISES(CPAIS) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE RAMAL ADD FOREIGN KEY (CODIGO_HEADEND , CODIGO_HUB , NUMNODE) REFERENCES NODE(CODIGO_HEADEND , CODIGO_HUB , NUMNODE) ON DELETE cascade ON UPDATE cascade^
ALTER TABLE TAP ADD FOREIGN KEY (CODIGO_HEADEND , CODIGO_HUB , NUMNODE , CODIGO_RAMAL) REFERENCES RAMAL(CODIGO_HEADEND , CODIGO_HUB , NUMNODE , CODIGO_RAMAL) ON DELETE cascade ON UPDATE cascade^

ALTER PROCEDURE INSERT_RGT_DIRECT2 (NUMABONNE INTEGER,PERIODE CHAR(7),DTCPT DATE,DTSAISIE DATE,NUMJRNL CHAR(3),LIB VARCHAR(50),NUMFACT INTEGER,MTTDEB DOUBLE PRECISION,MTTCRED DOUBLE PRECISION,MDRGLT CHAR(4),CODOPE VARCHAR(10),CODINSEE CHAR(5),TYPEC CHAR(4),CBOR CHAR(4),RESUMANU INTEGER,NUMLOTE VARCHAR(10),CODIGODEPAGO INTEGER) 
RETURNS  (NUMRGT INTEGER)
AS
declare variable numpiece integer;


begin

execute procedure incEC returning_values :numpiece;

insert into ecritcpt
(numpiece, numabonne, periode, dtcpt,  dtsaisie,  numjrnl,  lib,  numfact,  mttdeb,
 mttcred, mdrglt, reconcil, motifimp,codope, encaisse, reste, codinsee, typec, cbor, resumanu,
 numlote,codigodepago) 
values 
(:numpiece, :numabonne, :periode, :dtcpt, :dtsaisie, :numjrnl, :lib, :numfact, :mttdeb,
 :mttcred, :mdrglt, 'F', '', :codope, :mttcred,0, :codinsee, :typec, :cbor, :resumanu,
 :numlote,:codigodepago);

numrgt = numpiece;
SUSPEND;

end^

/*              Views              */
CREATE VIEW AVERIASINDETINTER  (numinter,numabonne,dtdeb,tipo,lib,motif,codprod,movimiento)
AS select numinter, numabonne, dtdeb, tipo, lib, motif, '0000' as codprod, 'Add' as movimiento
      from intervention
       where 
        estado = 'F' and intervention.tipo = 'Apl'^

COMMIT WORK^

